



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Guava-Optional可空类型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Guava-Optional可空类型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 10:09:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<p>接上篇Guava之Joiner和Splitter，本篇将介绍Guava的另外一个有用的对象Optional,这在Java中Google Guava首先给我们提出可空对象模型的。在其他语言如c#这是已经存在很久的模式，并包含在.net类库中Nullable(Int?也是一个可空类型)。</p>
<h2>Null sucks</h2>
<p>回到本文主题Optional。在我日常编程中NullPointerException是肯定是大家遇见最多的异常错误:</p>
<p>为此Doug Lea曾说过:</p>
<pre class="prettyprint linenums"><code>Null sucks.<br />
</code></pre>
<p>Sir C. A. R. Hoare也曾说过：</p>
<pre class="prettyprint linenums"><code>I call it my billion-dollar mistake.<br />
</code></pre>
<p>从上面我们能够足以看出NullPointerExceptiond的出现频率和可恨之处。因此在GOF的设计模式中我们也专门提出了空对象模式(或称特例模式)来应对这可恶的NullPointerExceptiond。空对象模式主要以返回一些<em>无意义并不影响处理逻辑的特定对象来替代null对象</em>，从而避免没必要的null对象的判断。 例如在计算一组员工的总共薪资的时候，对于返回的null对象则我们可以返回默认值为了<em>0</em>薪资的员工对象，那么我们就不需要做任何null的判断。</p>
<h2>员工薪资问题</h2>
<p>那么在Guava的Optional又该怎么解决呢？在讲解Optional之前，让我们仍然以计算一组员工的总共薪资为例用原生java代码将来看看：</p>
<div>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<pre class="prettyprint linenums"><code>@Test<br />
public void should_get_total_age_for_all_employees() throws Exception {<br />
    final List&lt;Employee&gt; list = Lists.newArrayList(new Employee("em1", 30), new Employee("em2", 40), null, new Employee("em4", 18));<br />
    int sum = 0;<br />
    for (Employee employee : list) {<br />
        if (employee != null) {<br />
            sum += employee.getAge();<br />
        }<br />
    }<br />
    System.out.println(sum);<br />
}<br />
private class Employee {<br />
    private final String name;<br />
    private final int age;<br />
    public Employee(String name, int age) {<br />
        this.name = name;<br />
        this.age = age;<br />
    }<br />
    public String getName() {<br />
        return name;<br />
    }<br />
    public int getAge() {<br />
        return age;<br />
    }<br />
}<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>如果换成Guava Optional将如何：</p>
<div>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<pre class="prettyprint linenums"><code> @Test<br />
public void should_get_total_age_for_all_employees() throws Exception {<br />
    final List&lt;Employee&gt; list = Lists.newArrayList(new Employee("em1", 30),<br />
        new Employee("em2", 40),<br />
         null,<br />
         new Employee("em4", 18));<br />
    int sum = 0;<br />
    for (Employee employee : list) {<br />
        sum += Optional.fromNullable(employee).or(new Employee("dummy", 0)).getAge();<br />
    }<br />
    System.out.println(sum);<br />
}<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>从上面可以清晰看出，我们不在担心对象对空了，利用Optional的fromNullable创建了一个可空对象，并将其or上一个dummy的员工信息，所以在这里我们不在担心NullPointerExceptiond。</p>
<p>也许你会说和利用三目运算 ( _<em>?</em>:_)没什么差别，在此例子中功能是的确是没多大差距，但是个人觉得Guava更有语义，更通用一些，而且满足很多空对象模式使用的场景。</p>
<h2>Optional API</h2>
<p>*. OptionalObject.isPresent(): 返回对象是否有值。</p>
<p>*. Optional.absent(): 返回一个空Optional对象,isPresent() 将会返回false</p>
<p>*. Optional.of(): 创Optional对象，输入参数不能为null</p>
<p>*. Optional.fromNullable(): 创Optional对象，输入可以为null</p>
<p>*. OptionalObject.asSet(): 和Optional对象值合并，如果为null则返回size为0的Set</p>
<p>*. OptionalObject.or(): 和Optional对象值合并，如果为null为空加则返回or参数作为默认值</p>
<p>*. OptionalObject.orNull(): 和Optional对象值合并，如果为null为空加则返回Null作为默认值</p>
<p>上面的api都是我们在使用Optional的时候最常用的方法属性方法，注意如果我们创建了Optional对象，但是没有判断isPresent()是否存在，就直接get这是会抛异常的，这属于乱用Optional情况，和直接用Null并没什么差别。</p>
<div>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<pre class="prettyprint linenums"><code>final Optional&lt;Object&gt; obj = Optional.fromNullable(null);<br />
final Object o = obj.get();<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>同样Optional为空对象模式，可以添加默认值，null不会影响我们的处理，如果为null我们无法继续程序处理的情况，需要抛异常或者中断的的，还是需要抛异常、中断，利用Preconditions.checkNotNull等，而不是继续套一层Optional对象，这也属于乱用Optional之列。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pwkdy8.html">APOC 15 Years Celebration</a>
		</li>
						<li><a href="https://www.batexi.com/a/495e01e9.html">python  os&period;system&lpar;&rpar;返回值判断</a>
		</li>
						<li><a href="https://www.batexi.com/a/495en6v9.html">PHP 常用字符串函数整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x0v1v8.html">文件系统层次标准FHS的详细介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnwgm2q.html">uvaIrrelevant Elements</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn501v8.html">POJ 1486 Sorting Slides &lpar;二分图关键匹配边&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd6rod8.html">免信用卡注册美国App Store账号</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ryn39.html">如何获得JVM执行过程中调用的方法名</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmkwxq.html">HTML全局属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnm4yd8.html">windows7实用快捷键                                                    分类：            windows常用小技巧             2014-04-18 14&colon;34    169人阅读    评论&lpar;0&rpar;    收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpn6169.html">DBGrid 各属性的设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j200x8.html">企业Centos服务器分区常用方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexw16q.html">聊聊属性方法property的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vroe8.html">试着把&period;net的GC讲清楚&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jn5d38.html">kubernetes 集群的安装部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rglx2d8.html">Dynamics CRM 2015Online Update1 new feature之 通过业务规则清空字段的值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwweyx9.html">java 幂等性（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jjzo3q.html">log4j日志的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jmxyjq.html">sqlserver开窗函数在财务对账中的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7odjee8.html">&lbrack;js&rsqb; 渲染树构建、布局及绘制</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49gze6e8.html">IOS  git 的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvj16zq.html">MMS彩信字符集&lpar;字符编码&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/495zgx69.html">Windows下解压版mysql的安装方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o31el8.html">MongoDB基本命令用</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r64zr9.html">【转】当你在浏览器地址栏输入一个URL后回车，将会发生的事情？</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2gx5x8.html">Android中如何查看so崩溃的log</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx6ll0q.html">javascript里面的数组，json对象，动态添加，修改，删除示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e3oxeq.html">SQL一致性错误修复SQL</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8myp068.html">MHA的在线切换后的一些总结（mha方案来自网络）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z64dvq.html">React的Diff算法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
